program Class;

type IdentType = ( TClass,TMethod );	{ Identifiers can be classes,methods }

type Identifier = record				{ Identifier record }
		Name 	: String;				{ Name }
		IType 	: IdentType;			{ What it is }
		ClassID : Integer;				{ Class number if method }
end;

const MaxIdent = 128;					{ How many we are allowed.... }

var ID:array[1..MaxIdent] of Identifier;
	IDCount:Integer;

function GetClassRef(c:String):Integer;	{ Find class ID given name }
var n:Integer;
begin
	n := 1;
	while (n <= IDCount) and
				((ID[n].Name <> c) or (ID[n].IType <> TClass)) do Inc(n);
	with ID[n] do
		begin
			Name := c;IType := TClass;ClassID := 0;
		end;
	if n > IDCount then IDCount := n;
	GetClassRef := n;
end;

procedure SUpper(var s:String);			{ String to upper case }
var i:integer;
begin
	for i := 1 to Length(s) do
					s[i] := UpCase(s[i]);
end;

procedure OOPConvert(var s:String);
var n:Integer;
	Class,Method:String;
begin
	WriteLn('; // ',s);
	n := Pos(';',s);
	if n > 0 then s := Copy(s,1,n-1);
	n := 1;
	while n <= Length(s) do
		begin
			if Ord(s[n]) <= 32 then Delete(s,n,1) else Inc(n);
		end;
	n := Pos('::',s);if n = 0 then Halt(0);
	Class := Copy(s,1,n-1);SUpper(Class);
	Method := Copy(s,n+2,99);SUpper(Method);

	if Class = '' then
		begin
			WriteLn('        ld   c,OM_',Method);
			WriteLn('        call OBSend');
		end
	else
		begin
			WriteLn('CL_',Class,'_MT_',Method,':');
            n := GetClassRef(Class);
            Inc(IDCount);
			with ID[IDCount] do
				begin
					Name := Method;
					IType := TMethod;
                    ClassID := n;
				end;
		end;
end;

var	i,n:Integer;
	f:Text;
	s:String;

begin
	IDCount := 0;
	for i := 1 to ParamCount do
		begin
			Assign(f,ParamStr(i));
			WriteLn(';');
			WriteLn(';   Translating "',ParamStr(i),'".');
			WriteLn(';');
			Reset(f);
			while not eof(f) do
				begin
					ReadLn(f,s);
                	if Pos('::',s) > 0
						then
							OOPConvert(s)
						else
							WriteLn(s);
				end;
			Close(f);
		end;

	WriteLn('; ===========================================================');
	for n := 1 to IDCount do
		if ID[n].IType = TClass then
			begin
				WriteLn('CL_',ID[n].Name,'_HANDLER:');
                WriteLn('        ld   a,c');
				for i := 1 to IDCount do
					if (ID[i].IType = TMethod) and (ID[i].ClassID = n) then
						begin
							WriteLn('        cp   OM_',ID[i].Name);
							WriteLn('        jp   z,CL_',ID[n].Name,'_MT_',ID[i].Name);
						end;
				if ID[n].Name = 'DEFAULT' then
					WriteLn('        ret')
				else
					WriteLn('        jp   CL_DEFAULT_HANDLER');
			end;


	WriteLn('__InitialiseHandlers:');
	for n := 1 to IDCount do
		if ID[n].IType = TClass then
			begin
				WriteLn('        ld hl,CL_',ID[n].Name,'_HANDLER');
				WriteLn('        ld (DispatchTable+(2*CL_',ID[n].Name,'),hl');
			end;
	WriteLn('        ret');
end.
